#pragma once
#include "afx.h"

class CHTTPRequest :public CObject
{
public:
  CHTTPRequest::CHTTPRequest(CListBox &messages,
                             int &maxExtent,
                             bool &bC,
                             CProgressCtrl &pC,
                             CList<CString,CString&> &pIT,
                             int nHTTPTimeout = 120);
  ~CHTTPRequest(void);
  int execute(const CString &strOriginalUrl,
              const CString &suggestedOutputFilename,
              bool bMemoryOnly);
  CString getData();
  CString getOutputFilename();
protected:
  CString data;
  CString outputFilename;
  void addMessage(const CString& text);
  void addMessageOneLine(const CString& text);
  void addHTMLMessage(const CString& text);
  int FindCaseInsensitive(const CString& string, const CString& stringSearch, int pos = 0);
  void addToList(CString string);
  CListBox &messagesListBox;
  int &maxListboxTextExtent;
  bool &bCancel;
  CProgressCtrl &progressControl;
  CList<CString,CString&> &progressInformationText;
  int nHTTPTimeout;
};
