// GeoCoderQueryThread.cpp: implementation file
//

#include "stdafx.h"

#include <afxtempl.h>

#include <list>
#include "Waypoint.h"

#include "geoDataClient.h"
#include "geoDataClientDialog.h"
#include "HTTPRequest.h"

// The static thread function. Calls CgeoDataClientDialog::GeoCoderQuery().
// Returns the number of errors or 0 if OK.
UINT CgeoDataClientDialog::GeoCoderQueryThread(LPVOID pParam)
{
  CgeoDataClientDialog *geoDataClientDialog = (CgeoDataClientDialog *)(pParam);
  return geoDataClientDialog->GeoCoderQuery();
}

// The non-static thread function.
// Returns the number of errors or 0 if OK.
UINT CgeoDataClientDialog::GeoCoderQuery()
{
  closeButton.EnableWindow(FALSE);
  proceedButton.EnableWindow(FALSE);
	CWnd *pLeft = GetDlgItem(IDC_EDIT_LEFT);
	if(pLeft) pLeft->EnableWindow(FALSE);
	CWnd *pTop = GetDlgItem(IDC_EDIT_TOP);
	if(pTop) pTop->EnableWindow(FALSE);

  allowedToEnableProceedButton = false; // Don't allow to enable that button until further notice.
  cancelButton.EnableWindow();

  CList<CString,CString&> progressInformationText;
  // progressInformationText is an empty list - no progress information.
  CHTTPRequest request(listBox,
                       maxListboxTextExtent,
                       bCancel,
                       progressControl,
                       progressInformationText,
                       nHTTPTimeout);
  CString queryGeoCoder; // The address finder query: http://www.geocoder.us
  queryGeoCoder.Format("http://geocoder.us/demo.cgi?address=%s", strAddress);
  int nResult = request.execute(queryGeoCoder, "", true);
  closeButton.EnableWindow();
  proceedButton.EnableWindow();
	if(pLeft) pLeft->EnableWindow();
	if(pTop) pTop->EnableWindow();
  allowedToEnableProceedButton = true; // If appropriate, that button may be enabled again.
  cancelButton.EnableWindow(FALSE);
  if(nResult == 0)
  {
    FilterGeocoderUS(request.getData());
  }
  else
  {
    SetStateError();
  }
  return nResult; // thread completed successfully
}
