// RemoveDir.cpp: implementation file
//

#include "stdafx.h"

// Returns 0 if OK.
int RemoveDir(const CString &directory)
{
  CFileFind finder;

  // build a string with wildcards
  CString strWildcard = directory + _T("\\*.*");

  // start working for files
  BOOL bWorking = finder.FindFile(strWildcard);

  while(bWorking)
  {
    bWorking = finder.FindNextFile();

    // skip . and .. files; otherwise, we'd
    // recur infinitely!

    if(finder.IsDots())
    {
      continue;
    }

    // if it's a directory, recursively search it

    if(finder.IsDirectory())
    {
      CString str = finder.GetFilePath();
      RemoveDir(str);
    }
    else
    {
      DeleteFile(finder.GetFilePath());
    }
  }
  finder.Close();
  if(!RemoveDirectory(directory))
  {
    LPVOID lpMsgBuf;
    if(!FormatMessage( 
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM | 
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        GetLastError(),
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
        (LPTSTR)&lpMsgBuf,
        0,
        NULL))
    {
      // Handle the error.
      return 1;
    }

    // Process any inserts in lpMsgBuf.
    // ...

    // Display the string.
    CString message;
    message.Format(_T("%s:\n%s"), directory, (LPCTSTR)lpMsgBuf);
    MessageBox(NULL, message, "Error", MB_OK | MB_ICONINFORMATION);

    // Free the buffer.
    LocalFree(lpMsgBuf);
    return 1;
  }
  else
  {
    return 0;
  }
}
