// TigerQuery.cpp: implementation file

#include "stdafx.h"

#include <afxtempl.h>
#include <math.h>

#include <list>
#include "Waypoint.h"

#include "geoDataClient.h"
#include "geoDataClientDialog.h"
#include "HTTPRequest.h"

// Call tiger.census.gov to get the texture GIF file.
// Returns 0 if OK.
int CgeoDataClientDialog::TigerQuery(const CString &gifFilenameTexture,
                                     double left,
                                     double right,
                                     double top,
                                     double bottom,
                                     int imagesize)
{
  CList<CString,CString&> progressInformationText;
  // progressInformationText is an empty list - no progress information.
  CHTTPRequest request(listBox,
                       maxListboxTextExtent,
                       bCancel,
                       progressControl,
                       progressInformationText,
                       nHTTPTimeout);
  CString queryTiger; // The Seamless query: http://extract.cr.usgs.gov
  queryTiger.Format("http://tiger.census.gov/cgi-bin/mapper/map.gif?lon=%0.8f&lat=%0.8f&wid=%0.8f&ht=%0.8f&iwd=%d&iht=%d&on=CITIES,GRID,counties,indian,majroads,miscell,places,railroad,shorelin,streets,interstate,statehwy,ushwy,states,water",
                    (left + right) * 0.5,
                    (top + bottom) * 0.5,
                    (right - left),
                    (top - bottom) * 1.04,
                    imagesize,
                    int(imagesize * 1.04 + 0.5));
  CString message;
  message.Format(_T("Executing HTTP request: \"%s\"."), queryTiger);
  addMessage(message);
  int nResult = request.execute(queryTiger, gifFilenameTexture, false);
  if(!nResult)
  {
    addMessage(_T("HTTP request was successful."));
  }
  else
  {
    addMessage(_T("Error processing HTTP request."));
  }
  return nResult;
}
